/***************************************************************************
 *                                                                         *
 *   cluster.h      (begin: Feb 20 2003)                                   *
 *                                                                         *
 *   Parallel IQPNNI - Important Quartet Puzzle with NNI                   *
 *                                                                         *
 *   Copyright (C) 2003-2004 by Le Sy Vinh, Arndt von Haeseler             *
 *   {vinh}@cs.uni-duesseldorf.de                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CLUSTER_H
#define CLUSTER_H
#include "constant.h"
#include "vec.h"

class Cluster {
public :
	int id_;
	int nObj_;
	int totalSeqNo_;
	double brLen_;
	int nSup_;
	Vec<int> seqNoArr_;

	Cluster ();

	void setId (int id);
	void add (Vec<int> &exNdNoLs, double brLen);
	int operator == (Cluster &cluster2);
	int operator [] (int index);
	~Cluster ();
};
#endif
